#!/usr/bin/env python
# coding: utf-8

# In[1]:


import pandas as pd
import numpy as np
import matplotlib.pyplot as plt 
from sklearn import tree
from sklearn import metrics
from sklearn.metrics import accuracy_score
get_ipython().system('pip install pydotplus')
get_ipython().system('pip install graphviz')
import pydotplus
from sklearn import linear_model
from sklearn.tree import DecisionTreeRegressor 
from sklearn import tree
  


# ## Reading and resampling of the data

# In[2]:



df = pd.read_csv('bed_temperature.csv', parse_dates =["time"], index_col ="time")
bed_temperature = pd.DataFrame()
bed_temperature["bed_temperature"] = df.resample('1H').mean().interpolate()
df.drop_duplicates(inplace=True)



df = pd.read_csv('ext_temperature.csv', parse_dates =["time"], index_col ="time")
ext_temperature = pd.DataFrame()
ext_temperature["ext_temperature"] = df.resample('1H').mean().interpolate()



df = pd.read_csv('CO2.csv', parse_dates =["time"], index_col ="time")
CO2 = pd.DataFrame()
CO2["CO2"] = df.resample('1H').mean().interpolate()

inputdata = pd.concat([ ext_temperature,bed_temperature,CO2],axis=1,join="inner")
inputdata


# In[3]:



inputdata.plot(subplots=True,figsize=(20, 10))


# In[4]:


inputdata.dtypes


# #### Linear Regression to predict the CO2 level in the bedroom
# 

# In[5]:


X=inputdata[['bed_temperature','ext_temperature']]
Y=inputdata[['CO2']]


# In[6]:


X


# In[7]:


Y


# In[8]:


regr=linear_model.LinearRegression()
regr.fit(X,Y)


# In[24]:


predictCO2 = regr.predict([[7,19]])
predictCO2


# In[15]:


regressor = DecisionTreeRegressor(max_depth=2,random_state = 0) 
regressor.fit(bed_temperature,CO2)


# In[16]:


plt.scatter(bed_temperature,CO2, color = 'red')
plt.plot(bed_temperature, regressor.predict(bed_temperature), color = 'blue')
plt.title('Thermal comfort(Regression Model)')
plt.xlabel('Bedroom temperature')
plt.ylabel('CO2 level')
plt.show()


# #### Decision Tree Regression to predict the CO2 level in the bedroom
# 

# In[14]:


from sklearn.model_selection import train_test_split
X_train,X_test,Y_train,Y_test=train_test_split(X,Y,test_size=0.2,random_state=1)


# In[15]:


from sklearn.tree import DecisionTreeRegressor
regressor2= DecisionTreeRegressor(random_state=0)
regressor2.fit(X_train,Y_train)


# In[16]:


y_pred2= regressor2.predict(X_test)
y_pred2


# #### R2 Score

# In[17]:


from sklearn.metrics import r2_score
r2_score(Y_test,y_pred2)


# #### Mean absolute error

# In[26]:


mse = metrics.mean_absolute_error(Y_test, y_pred2)
mse


# In[ ]:


tree.plot_tree(regressor2)


# In[ ]:





# In[ ]:




